# coding: utf-8

"""
    Payment Gateway API Specification

    Payment Gateway API for payment processing.   # noqa: E501

    OpenAPI spec version: 0.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from swagger_client.models.pay_pal import PayPal  # noqa: F401,E501
from swagger_client.models.payment_card import PaymentCard  # noqa: F401,E501
from swagger_client.models.sepa import Sepa  # noqa: F401,E501


class PaymentMethod(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'type': 'str',
        'payment_card': 'PaymentCard',
        'sepa': 'Sepa',
        'pay_pal': 'PayPal'
    }

    attribute_map = {
        'type': 'type',
        'payment_card': 'paymentCard',
        'sepa': 'sepa',
        'pay_pal': 'payPal'
    }

    def __init__(self, type=None, payment_card=None, sepa=None, pay_pal=None):  # noqa: E501
        """PaymentMethod - a model defined in Swagger"""  # noqa: E501

        self._type = None
        self._payment_card = None
        self._sepa = None
        self._pay_pal = None
        self.discriminator = None

        self.type = type
        if payment_card is not None:
            self.payment_card = payment_card
        if sepa is not None:
            self.sepa = sepa
        if pay_pal is not None:
            self.pay_pal = pay_pal

    @property
    def type(self):
        """Gets the type of this PaymentMethod.  # noqa: E501

        The type of payment method. Note that PayPal can only process a 'Credit'  primary transaction with Order.Billing.Contact.email being mandatory. PayPal secondary transactions (void/return/postauth) are processed the same as any other secondary transactions.  # noqa: E501

        :return: The type of this PaymentMethod.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this PaymentMethod.

        The type of payment method. Note that PayPal can only process a 'Credit'  primary transaction with Order.Billing.Contact.email being mandatory. PayPal secondary transactions (void/return/postauth) are processed the same as any other secondary transactions.  # noqa: E501

        :param type: The type of this PaymentMethod.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["PAYMENT_CARD", "SEPA", "PAYPAL"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def payment_card(self):
        """Gets the payment_card of this PaymentMethod.  # noqa: E501


        :return: The payment_card of this PaymentMethod.  # noqa: E501
        :rtype: PaymentCard
        """
        return self._payment_card

    @payment_card.setter
    def payment_card(self, payment_card):
        """Sets the payment_card of this PaymentMethod.


        :param payment_card: The payment_card of this PaymentMethod.  # noqa: E501
        :type: PaymentCard
        """

        self._payment_card = payment_card

    @property
    def sepa(self):
        """Gets the sepa of this PaymentMethod.  # noqa: E501


        :return: The sepa of this PaymentMethod.  # noqa: E501
        :rtype: Sepa
        """
        return self._sepa

    @sepa.setter
    def sepa(self, sepa):
        """Sets the sepa of this PaymentMethod.


        :param sepa: The sepa of this PaymentMethod.  # noqa: E501
        :type: Sepa
        """

        self._sepa = sepa

    @property
    def pay_pal(self):
        """Gets the pay_pal of this PaymentMethod.  # noqa: E501


        :return: The pay_pal of this PaymentMethod.  # noqa: E501
        :rtype: PayPal
        """
        return self._pay_pal

    @pay_pal.setter
    def pay_pal(self, pay_pal):
        """Sets the pay_pal of this PaymentMethod.


        :param pay_pal: The pay_pal of this PaymentMethod.  # noqa: E501
        :type: PayPal
        """

        self._pay_pal = pay_pal

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentMethod):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
